package de.tu_darmstadt.tk.SmartHomeNetworkSim.core.simpleImplementation;

import java.util.Collection;
import java.util.Iterator;
import java.util.Random;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.control.Controller;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.NetworkManipulationAlgorithm;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.SmartDevice;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.devices.FloatCollectorDevice;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.devices.FloatSensorDevice;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.distributionHandler.ConstantValueDistributionHandler;

public class ValueAnomaly implements NetworkManipulationAlgorithm {
	
	@Override
	public void runAlgorithm(Controller controller, long currentTimeStep) {
		
		Collection<SmartDevice> devices = controller.getNetworkController().getVisibleSmartDevices();
		if(devices.isEmpty())return;
		
		Iterator<SmartDevice> it = devices.iterator();
		
		SmartDevice hub = null;
		//Find Hub
		while(it.hasNext()){
			if(it.next() instanceof FloatSensorDevice) {
				if(currentTimeStep % 5 == 0) {
					FloatSensorDevice thermostat = (FloatSensorDevice) it.next();
					thermostat.setFSmax(100);
					thermostat.setFSmin(50);
					thermostat.setFSval((float)(50 + (Math.random() * ((100 - 50) + 1)))); // Intervall (50, 100)
				}
				if(currentTimeStep % 2 == 0) {
					FloatSensorDevice thermostat = (FloatSensorDevice) it.next();
					thermostat.setFSmax(5);
					thermostat.setFSmin(0);
					thermostat.setFSval((float)(Math.random() * 6)); // Intervall (0, 6)
				}
				break;
			}
		}
		
		controller.notifyObservers();
	}

}
